; Input DE points to command buffer start
; HL points to command table

startCode
		ld	de,cmd_buffer
		call	parse

		jp	$

cmd_buffer
;    		db	"cls"
    		db	"videomode"
		ds	255,0

parse
		ld	hl,table

eat_space
		ld	a,(de)
		cp	#00
		ret	z			; if reach to the end of buffer
		cp	#20			; check for space
		jp	nz, parse_start
		inc	de
		jp	eat_space

parse_start
		ld      a,(de)
		cp	#00			; space means end of buffer
		jp	z,end_of_command
		cp	#20			; space means end of command
		jp	z,end_of_command
		cp	(hl)			; Compare a with first character in command table
		jp	nz,next_command		; Move HL to point to the first character of the next command in the table
		inc	de
		inc	hl
		jp	parse_start

next_command
		push af
		ld	a, "*"
		cp	(hl)			; Is it the end off command * ?
		jp	z,forward		; Yes inc HL 3 times to set to begining of next command in the table

		ld	a,"@"			; Table end reached ?
		cp	(hl)
		jp	z,no_match
		pop	af
		inc	hl
                jp	next_command

forward
		pop	af
		inc	hl
		inc	hl
		inc	hl
		jp	parse_start

end_of_command
		inc	hl			; increase to *
						; Increase to point to jump vector for command
		ld	a,(hl)
		inc	hl
		ld	h,(hl)
		ld	l,a
		jp	(hl)

no_match
		pop	af
						; Routine to print "Unkown command error"
		ret

; Command table below with all jump vectors.

table
		db	"cls"			; Command
		db	"*"			; 1 byte
		dw	jumpvector1		; 2 bytes

		db	"videomode"		; Command
		db	"*"			; 1 byte
		dw	jumpvector2		; 2 bytes

		db	"@"			; table end marker

jumpvector1
		ld	a,4
		out	(254),a			;example1
		ret

jumpvector2
		ld	a,3
		out	(254),a			;example2
		ret

endCode		nop
